BasicCodecLookup (Grails 4.0.0)
Date: 2019-07-11

Package: org.grails.encoder.impl

## [Java] Class BasicCodecLookup

- org.grails.encoder.impl.BasicCodecLookup

- All Implemented Interfaces and Traits:
    CodecLookup, org.springframework.beans.factory.InitializingBean

      public class BasicCodecLookup
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static StreamingEncoder` | `NONE_ENCODER` |
    `protected java.util.concurrent.ConcurrentMap<java.lang.String, Decoder>` | `decoders` |
    `protected java.util.concurrent.ConcurrentMap<java.lang.String, Encoder>` | `encoders` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `BasicCodecLookup ()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `afterPropertiesSet()`
    `<T extends CodecIdentifierProvider>` | `protected T` | `createChainedCodecInstance(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)`
    `<T extends CodecIdentifierProvider>` | `protected T` | `createCodec(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)`
    `` | `protected java.util.Collection<java.lang.String>` | `createNameVariations(java.lang.String name, CodecIdentifierProvider target)`
    `<T extends CodecIdentifierProvider>` | `protected T` | `lookupCodec(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)`
    `` | `Decoder` | `lookupDecoder(java.lang.String codecName)`
    `` | `Encoder` | `lookupEncoder(java.lang.String codecName)`
    `<T extends CodecIdentifierProvider>` | `protected T` | `putChainedCodecInstance(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, T createdInstance)`
    `` | `void` | `reInitialize()`
    `` | `void` | `registerCodecFactory(CodecFactory codecFactory)`
    `` | `protected void` | `registerCodecs()`
    `` | `void` | `registerDecoder(Decoder decoder)`
    `` | `void` | `registerEncoder(Encoder encoder)`
    `<T extends CodecIdentifierProvider>` | `protected void` | `registerVariationsOfName(java.util.Map<java.lang.String, T> destinationMap, T target, java.lang.String name)`
    `<T extends CodecIdentifierProvider>` | `protected void` | `registerWithNameVaritions(java.util.Map<java.lang.String, T> destinationMap, T target)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### public static final StreamingEncoder NONE_ENCODER

    - #### protected final java.util.concurrent.ConcurrentMap<java.lang.String, Decoder> decoders

    - #### protected final java.util.concurrent.ConcurrentMap<java.lang.String, Encoder> encoders

  - ### Constructor Detail

    - #### public BasicCodecLookup()

  - ### Method Detail

    - #### public void afterPropertiesSet()

    - #### <T extends CodecIdentifierProvider> protected T createChainedCodecInstance(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)

    - #### <T extends CodecIdentifierProvider> @java.lang.SuppressWarnings("unchecked") protected T createCodec(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)

    - #### protected java.util.Collection<java.lang.String> createNameVariations(java.lang.String name, CodecIdentifierProvider target)

    - #### <T extends CodecIdentifierProvider> @java.lang.SuppressWarnings("unchecked") protected T lookupCodec(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, java.lang.Class<T> returnType)

    - #### public Decoder lookupDecoder(java.lang.String codecName)

    - #### public Encoder lookupEncoder(java.lang.String codecName)

    - #### <T extends CodecIdentifierProvider> protected T putChainedCodecInstance(java.lang.String codecName, java.util.concurrent.ConcurrentMap<java.lang.String, T> map, T createdInstance)

    - #### public void reInitialize()

    - #### public void registerCodecFactory(CodecFactory codecFactory)

    - #### protected void registerCodecs()

    - #### public void registerDecoder(Decoder decoder)

    - #### public void registerEncoder(Encoder encoder)

    - #### <T extends CodecIdentifierProvider> protected void registerVariationsOfName(java.util.Map<java.lang.String, T> destinationMap, T target, java.lang.String name)

    - #### <T extends CodecIdentifierProvider> protected void registerWithNameVaritions(java.util.Map<java.lang.String, T> destinationMap, T target)